package jex;

import com.sun.star.bridge.XUnoUrlResolver;
import com.sun.star.lang.XMultiServiceFactory;
import com.sun.star.lang.XServiceInfo;
import com.sun.star.lang.XComponent;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.uno.XComponentContext;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XInterface;
import com.sun.star.frame.XComponentLoader;
import com.sun.star.beans.PropertyValue;
import com.sun.star.beans.Property;
import com.sun.star.beans.XPropertySetInfo;
import com.sun.star.frame.XDesktop;
import com.sun.star.frame.XFrame;
import com.sun.star.frame.XController;
import com.sun.star.frame.XModel;
import com.sun.star.frame.XDispatchHelper;
import com.sun.star.frame.XDispatchProvider;
import com.sun.star.view.XSelectionSupplier;
import com.sun.star.view.XLineCursor;
import com.sun.star.container.XIndexAccess;
import com.sun.star.container.XNameAccess;
import com.sun.star.container.XEnumerationAccess;
import com.sun.star.text.XText;
import com.sun.star.text.XTextRange;
import com.sun.star.text.XTextFrame;
import com.sun.star.text.XTextContent;
import com.sun.star.text.XTextViewCursorSupplier;
import com.sun.star.text.XTextViewCursor;
import com.sun.star.text.XTextCursor;
import com.sun.star.text.TextContentAnchorType;
import com.sun.star.text.VertOrientation;
import com.sun.star.text.XTextEmbeddedObject;
import com.sun.star.text.XTextDocument;
import com.sun.star.text.ControlCharacter;
import com.sun.star.text.XTextGraphicObjectsSupplier;
import com.sun.star.beans.XPropertySet;
import com.sun.star.drawing.XShape;
import com.sun.star.drawing.XShapeGrouper;
import com.sun.star.drawing.XShapes;
import com.sun.star.drawing.XDrawPageSupplier;
import com.sun.star.drawing.HomogenMatrixLine3;
import com.sun.star.drawing.HomogenMatrix3;
import com.sun.star.awt.Size;
import com.sun.star.awt.FontWeight;
import com.sun.star.awt.Point;
import com.sun.star.awt.XWindow;
import com.sun.star.table.BorderLine;
import com.sun.star.util.XSearchable;
import com.sun.star.util.XSearchDescriptor;
import com.sun.star.container.XNameAccess;
import com.sun.star.container.XContentEnumerationAccess;
import com.sun.star.container.XEnumeration;
import com.sun.star.awt.FontSlant;
import com.sun.star.connection.*;

import java.awt.Color;
import java.util.*;
import java.io.*;
import java.net.URI;
import java.util.zip.*;

import jex.Jex;
import jex.Jexmath;
import jex.Jexwmf;

public class Jexoo implements MathDisplay, Office {
     
    static String connectStr = "uno:socket,host=localhost,port=8100;urp;StarOffice.ServiceManager";
    public static XDesktop xd;
    public static XDispatchHelper xdh;
    static XComponentContext xcctxt;
    static String jexexec = "";
    static String userLoc = "";
    static String shareLoc = "";
    static String javaLoc = "";
    static String euclid = "";
    static boolean server = false;
    static boolean checkExit = false;

    public Jex jex;
    public String jexname = null;

    public Jexoo(Jex jex) {
	this.jex = jex;
    }

    public Jexoo(){}

    public void unzipTo(String zipfile, String target, boolean isUri){
	//System.out.println(zipfile + " " + target);
	try{
		FileInputStream in = new FileInputStream(zipfile);
		ZipInputStream zip = new ZipInputStream(in);
		int nmax = 10000000; 
		byte b[] = new byte[nmax];
		for(ZipEntry ze = zip.getNextEntry(); ze != null; ze = zip.getNextEntry()){
			int nread = 0;
			int tread = 0;
			while((tread = zip.read(b, nread, nmax - nread - 1)) >= 0){
				nread = nread + tread;
			}
			File wfile = null;
			if(isUri) {
				String towrite = target + "/" + ze.getName();
				URI uri = new URI(towrite);
				wfile = new File(uri);
			}
			else {
				wfile = new File(target + File.separator + ze.getName());
			}
			FileOutputStream out = new FileOutputStream(wfile);
			out.write(b, 0, nread);
			out.close();
		}		
	}
	catch(Exception ex){System.err.println(ex);}
    }

    public void installOffice(){
		officeLoc();
		URI uri = null;
		try {uri = new URI(userLoc + "/jexpath.txt");}
		catch(Exception e){System.err.println(e);}
		File jexpath = new File(uri);
		String javaexec = javaLoc + "/bin/java";
		File test = new File(javaexec);
		if(!test.exists()) {
			javaexec = "file:///" + javaexec + ".exe";
			javaexec = javaexec.replaceAll(" ", "%20");
			javaexec = javaexec.replace('\\', '/');
			javaexec = javaexec;
		}
 		javaexec = javaexec + " -jar " + jexexec + " --server";
		try{
			FileOutputStream out = new FileOutputStream(jexpath);
			out.write(javaexec.getBytes());
			out.close();
		}
		catch(IOException ex){};
    }

    public void installFonts(){
	officeLoc();
	unzipTo(euclid, shareLoc + "/../fonts/truetype", true);
    }
    public void installJavaFonts(){
	unzipTo(euclid, javaLoc + File.separator + "lib" + File.separator + "fonts", false);
    }
    public boolean queryExit(){
		if(!server) return true;
		checkExit = true;
		return false;
    }

    public void officeLoc(){
	if(userLoc == ""){
		connect();
		XMultiComponentFactory xsvcm = xcctxt.getServiceManager();
		try {
			Object pathSubst = xsvcm.createInstanceWithContext("com.sun.star.comp.framework.PathSettings", xcctxt);
			XPropertySet xPathPS = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, pathSubst);
			userLoc = (String) xPathPS.getPropertyValue("UserConfig");
			shareLoc = (String) xPathPS.getPropertyValue("Config");
		}
		catch(Exception exception){System.err.println("officeLoc exception: " + exception);}
	}
    }
    
    public static void connect(){
    
        try{    
            xcctxt = com.sun.star.comp.helper.Bootstrap.createInitialComponentContext(null);
            XMultiComponentFactory xmcf = xcctxt.getServiceManager();
            Object objectUrlResolver = xmcf.createInstanceWithContext("com.sun.star.bridge.UnoUrlResolver", xcctxt);
            XUnoUrlResolver xurlr = (XUnoUrlResolver) UnoRuntime.queryInterface( XUnoUrlResolver.class, objectUrlResolver );
            Object object0 = xurlr.resolve(connectStr);
            xmcf = (XMultiComponentFactory)  UnoRuntime.queryInterface(XMultiComponentFactory.class, object0);
            XPropertySet xpsmcf = (XPropertySet) UnoRuntime.queryInterface(XPropertySet.class, xmcf);
            Object odc = xpsmcf.getPropertyValue("DefaultContext");
            xcctxt = (XComponentContext) UnoRuntime.queryInterface(XComponentContext.class, odc);
            xd = (XDesktop) UnoRuntime.queryInterface(XDesktop.class, xmcf.createInstanceWithContext("com.sun.star.frame.Desktop", xcctxt));
            xdh = (XDispatchHelper) UnoRuntime.queryInterface(XDispatchHelper.class, xmcf.createInstanceWithContext("com.sun.star.frame.DispatchHelper", xcctxt));
        }
        catch(Exception exception) {
            System.err.println("connect exception: " +  exception);
	    xd = null;
        }
    }
    
    Object objectS;
    XTextViewCursor xvc;
    XComponent xcc;
    XTextDocument xdoc;
    XMultiServiceFactory xmsf;
    XModel xm;
    XController xc2;
    XFrame xgf;
    XDispatchProvider xdp;

    
    void getCurrent(){
	if(xd == null) connect();
	try{
        	xgf = xd.getCurrentFrame();
	}
	catch(Exception e){
		System.err.println("getCurrent exception: " + e);
		xd = null;
		connect();
		if(xd == null) return;
		xgf = xd.getCurrentFrame();
	}
        XController xc = xgf.getController();
        XSelectionSupplier xss = (XSelectionSupplier) UnoRuntime.queryInterface(XSelectionSupplier.class, xc);
	if(xss == null) System.out.println("no selection");
        objectS = xss.getSelection();
        xcc = xd.getCurrentComponent();
	xdoc = (XTextDocument)UnoRuntime.queryInterface(XTextDocument.class, xcc);
        xmsf = (XMultiServiceFactory) UnoRuntime.queryInterface(XMultiServiceFactory.class, xcc);
        xm = (XModel) UnoRuntime.queryInterface(XModel.class, xcc);
        xc2 = xm.getCurrentController();
        XTextViewCursorSupplier xtvcs = (XTextViewCursorSupplier) UnoRuntime.queryInterface(XTextViewCursorSupplier.class, xc2);
        xvc = xtvcs.getViewCursor();
	xdp = (XDispatchProvider) UnoRuntime.queryInterface(XDispatchProvider.class, xc2);
    }
    
    public static void main(String args[]) {
	Jex.officeclass = new Jexoo();
        connect();
	ooListen ool = new ooListen();
	ool.start();
        Jex jex = Jex.initJ(args);
	for(int ii = 0; ii < args.length; ii++) {
		if(args[ii].trim().equals("--server")) {
			server = true;
			ooCheckExit ooce = new ooCheckExit();
			ooce.start();
		}
	}
	Jexoo jexoo = new Jexoo(jex);
	jexoo.setJex(jex);
	if(server) jexoo.grabIn(jex, jexoo);
	//jex.gJexFrame.setState(java.awt.Frame.ICONIFIED);
	javaLoc = System.getProperty("java.home");
	String os = System.getProperty("os.name").toLowerCase() + "xxxxxxx";
	try {
		String url = Jexoo.class.getResource("Jexoo.class").toString();
		url = url.replaceAll("jar:", "");
		url = url.replaceAll("!/jex/Jexoo.class", "");
		URI uri = new URI(url);
		File jexexecf = new File(uri);
		String quotes = "";
		if(os.substring(0,7).equals("windows")) quotes = "\"";
		String confjex = jexexecf.getAbsolutePath().replaceAll("jex.jar", "conf.jex");
		euclid = jexexecf.getAbsolutePath().replaceAll("jex.jar", "euclid.zip");
		jexexec = quotes + jexexecf.getAbsolutePath() + quotes + " " + quotes + confjex + quotes;
	}
	catch(Exception e){System.err.println(e);}
    }

    public void setJex(Jex jex){
	jex.setMathDisplay(this);
	jex.setOffice(this);
    }

    //public MathDisplay getNewMathDisplay(Object jex){
    //	return new Jexoo((Jex) jex);
    //}
    
    XTextFrame xf;
    XShapes xss;
    int fsize;
    int hf = 35;
    int vf = 35;
    int base;
    PropertyValue[] cpv;

    private void setProp(int i, String name, String value){
		cpv[i] = new com.sun.star.beans.PropertyValue();
		cpv[i].Name = name;
		cpv[i].Value = value;
    }

    private void setProp(int i, String name, int value){
		cpv[i] = new com.sun.star.beans.PropertyValue();
		cpv[i].Name = name;
		cpv[i].Value = new Integer(value);
    }

    private void setProp(int i, String name, boolean value){
		cpv[i] = new com.sun.star.beans.PropertyValue();
		cpv[i].Name = name;
		cpv[i].Value = new Boolean(value);
    }

    private boolean findview(String str){
		PropertyValue pv[] = new com.sun.star.beans.PropertyValue[19];
		cpv = pv;
		setProp(0, "SearchItem.StyleFamily", 2);
		setProp(1, "SearchItem.CellType", 0);
		setProp(2, "SearchItem.RowDirection", true);
		setProp(3, "SearchItem.AllTables", false);
		setProp(4, "SearchItem.Backward", true);
		setProp(5, "SearchItem.Pattern", false);
		setProp(6, "SearchItem.Content", false);
		setProp(7, "SearchItem.AsianOptions", false);
		setProp(8, "SearchItem.AlgorithmType", 0);
		setProp(9, "SearchItem.SearchFlags", 65536);
		setProp(10, "SearchItem.SearchString", str);
		setProp(11, "SearchItem.ReplaceString", "");
		setProp(12, "SearchItem.Locale", 255);
		setProp(13, "SearchItem.ChangedChars", 2);
		setProp(14, "SearchItem.DeletedChars", 2);
		setProp(15, "SearchItem.InsertedChars", 2);
		setProp(16, "SearchItem.TransliterateFlags", 1280);
		setProp(17, "SearchItem.Command", 0);
		setProp(18, "Quiet", true);  
		Boolean b = (Boolean) xdh.executeDispatch(xdp, ".uno:ExecuteSearch", "", 0, pv);
		if(!b.booleanValue()){
			setProp(4, "SearchItem.Backward", false);
			b = (Boolean) xdh.executeDispatch(xdp, ".uno:ExecuteSearch", "", 0, pv);
			return(b.booleanValue()); 
		}		
		return true;
    }

    private String tfile;

    public void printEq(String tex, DefaultContext d){

	getCurrent();
	try{
		if(jexname != null){
			boolean found = false;
			XShape xs = (XShape) UnoRuntime.queryInterface(XShape.class, objectS);
			if(xs != null){
				XPropertySet xsp = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, objectS);
				String str = (String) xsp.getPropertyValue("LinkDisplayName");
				if(str.equals(jexname)) found = true;
			}
			XTextContent xt;
			if(!found){	
				XPropertySet xsp;	
				XTextGraphicObjectsSupplier xgos = (XTextGraphicObjectsSupplier)UnoRuntime.queryInterface(XTextGraphicObjectsSupplier.class, xcc);
				XNameAccess xna = xgos.getGraphicObjects();
				Object something = xna.getByName(jexname);		
				xt = (XTextContent) UnoRuntime.queryInterface(XTextContent.class, something);
			}
			else {
				xt = (XTextContent) UnoRuntime.queryInterface(XTextContent.class, objectS);
				xdh.executeDispatch(xdp, ".uno:Escape", "", 0, null);
			}
      			XText xdt = xdoc.getText();
			XTextRange xtr = xt.getAnchor();
			XTextCursor xma = xdt.createTextCursorByRange(xtr);
        		xma.goLeft((short)1, false);
			xma.goRight((short)1, false);
			String tname = getName();
			xdt.insertString(xma, tname, true);
			findview(tname);
			xdh.executeDispatch(xdp, ".uno:Delete", "", 0, null);
			xdt.insertString(xma, "", true);
			xvc.goRight((short) 1, true);
		}	
		insertEq(tex, d);
	}
	catch(Exception exception){System.err.println(
		"printEq: " + exception);
		xdh.executeDispatch(xdp, ".uno:Delete", "", 0, null);
		insertEq(tex, d);
	}
    }

    private void insertEq(String tex, DefaultContext d){
        try{
		getCurrent();
		XTextContent xt = (XTextContent) UnoRuntime.queryInterface(XTextContent.class, objectS);
		if(xt != null) xdh.executeDispatch(xdp, ".uno:Delete", "", 0, null);

            	XText xdt = xvc.getText();
           	XTextCursor xma = xdt.createTextCursorByRange(xvc.getStart());

		XPropertySet xspt = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xma);
		Jexwmf wmf = new Jexwmf();
		File tfilef = File.createTempFile("jex", ".wmf");
		tfilef.deleteOnExit();
		tfile = tfilef.getAbsolutePath();
		wmf.tfile = tfile;
		Float xsptf = (Float) xspt.getPropertyValue("CharHeight");
		wmf.fsize0 = xsptf.floatValue();
		wmf.printEq(tex, d);

		xdt.insertString(xma, "a", true);
		xdh.executeDispatch(xdp, ".uno:InsertPara", "", 0, null);
		xdh.executeDispatch(xdp, ".uno:InsertPara", "", 0, null);
		PropertyValue pvx[] = new com.sun.star.beans.PropertyValue[2];
		cpv = pvx;
		setProp(0, "Count", 1);
		setProp(1, "Select", false);
		xdh.executeDispatch(xdp, ".uno:GoLeft", "", 0, pvx);
 
		PropertyValue pv[] = new com.sun.star.beans.PropertyValue[4];
		cpv = pv;
		setProp(0, "FileName", "file://" + tfile);
		setProp(1, "FilterName", "<All formats>");
		setProp(2, "AsLink", false);
		setProp(3, "Style", "Graphics");
		xdh.executeDispatch(xdp, ".uno:InsertGraphic", "", 0, pv);
		getCurrent();
		xdh.executeDispatch(xdp, ".uno:SetAnchorToChar", "", 0, null);
		xdh.executeDispatch(xdp, ".uno:AlignVerticalCenter", "", 0, null);
		xdh.executeDispatch(xdp, ".uno:Escape", "", 0, null);		

		XShape xs = (XShape) UnoRuntime.queryInterface(XShape.class, objectS);
		XPropertySet xsp = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, objectS);
		xsp.setPropertyValue("ContentProtected", new Boolean(true));
            	//xsp.setPropertyValue("AnchorType", TextContentAnchorType.AS_CHARACTER);
		xsp.setPropertyValue("AlternativeText", "jex149$tex=" + tex);
		jexname = (String) xsp.getPropertyValue("LinkDisplayName");
		jex.setTitle(jexname);
		//xsp.setPropertyValue("VertOrient", new Integer(3));
		//xsp.setPropertyValue("VertOrientPosition", new Integer(212));

	    	//XPropertySetInfo xps = xsp.getPropertySetInfo();
            	//Property xgp[] = xps.getProperties();
            	//for (int jj = 0; jj < xgp.length; jj++){
		//	System.out.println(xgp[jj].Name + " " + xsp.getPropertyValue(xgp[jj].Name));
	    	//}

		xt = (XTextContent) UnoRuntime.queryInterface(XTextContent.class, objectS);
		XTextRange xtr = xt.getAnchor();
		xma = xdt.createTextCursorByRange(xtr);
            	xma.goLeft((short) 2, true);
		xdt.insertString(xma, "", true);

		xma.goRight((short) 1, false);
		xma.goRight((short) 1, true);
		xdt.insertString(xma, "", true);

		//unfortunately the next code did not solve the disappearing graphics problem
		//pv = new com.sun.star.beans.PropertyValue[1];
		//cpv = pv;
		//setProp(0, "Graphic", false);
		//xdh.executeDispatch(xdp, ".uno:Graphic", "", 0, pv);

		//pv = new com.sun.star.beans.PropertyValue[1];
		//cpv = pv;
		//setProp(0, "Graphic", true);
		//xdh.executeDispatch(xdp, ".uno:Graphic", "", 0, pv);


	}
        catch( Exception exception ) {
            System.err.println("insertEq exception: " + exception );
        }

    }

    public void showChar(String str, String face, String style, int size, float stretch, float aftr, int x, double y, BoxMetrics m, int vshift){}

    public void setName(String name){
	jexname = name;
    }

    public String getName(){
	GregorianCalendar cal = new GregorianCalendar();
	return "Jex$$" + cal.getTimeInMillis();
    }

    public void grabIn(Jex jex, Jexoo jexoo){
    	try {
	    getCurrent();
	    XShape xs = (XShape) UnoRuntime.queryInterface(XShape.class, objectS);
	    if(xs != null){
	    	XPropertySet xsp = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xs);
            	String tex = (String) xsp.getPropertyValue("AlternativeText");
		int n = tex.indexOf("=");
		if(n > 0) tex = tex.substring(n+1);
		String name = (String) xsp.getPropertyValue("LinkDisplayName");
	    	jex.jexPane.setEqn(tex);
		jexoo.setName(name);
		jex.setTitle(name);
	    }
        }
        catch( Exception exception ) {
            System.err.println("grabEq: " + exception );
        }
    }


    public void grabEq(){
    
        try {
            getCurrent(); 


	    XShape xs = (XShape) UnoRuntime.queryInterface(XShape.class, objectS);
	    if(xs == null){
		Jex jex = Jex.newJex("{}");
		Jexoo jexoo = new Jexoo(jex);
		jexoo.setJex(jex);
	    }
	    else{
	    	XPropertySet xsp = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xs);
            	String tex = (String) xsp.getPropertyValue("AlternativeText");
		int n = tex.indexOf("=");
		if(n > 0) tex = tex.substring(n+1);
		String name = (String) xsp.getPropertyValue("LinkDisplayName");
	    	Jex jex = Jex.newJex(tex);
		Jexoo jexoo = new Jexoo(jex);
		jexoo.setName(name);
		jexoo.setJex(jex);
		jex.setTitle(name);
	    }
        }
        catch( Exception exception ) {
            System.err.println("grabEq: " + exception );
        }
    }
}

class ooCheckExit extends Thread {

	public void run() {
		while(true){
			if(Jexoo.checkExit){
				if(Jex.nWins > 0) Jexoo.checkExit = false;
				else {
					Jexoo.connect();
					if(Jexoo.xd == null) {
						System.exit(0);
					}
				}
			}
			try{
				sleep(20000);
			}
			catch(Exception exception){
				System.err.println("ooCheckExit exception: " + exception);
			}
		}
	}
}
		

class ooListen extends Thread {

	Jexoo jexoo;

	private String getMsg(XConnection xc){
		byte b[][]= new byte[1][10];
		try {xc.read(b, 5);}
		catch(Exception e){System.err.println(e);}
		return new String(b[0]);
	}

	public void run () {
	
		while(true){

		try{

            		XComponentContext xcc = com.sun.star.comp.helper.Bootstrap.createInitialComponentContext(null);
            		XMultiComponentFactory xmsf = xcc.getServiceManager();
			Object aa = xmsf.createInstanceWithContext("com.sun.star.connection.Acceptor", xcc);
			XAcceptor xa = (XAcceptor) UnoRuntime.queryInterface(XAcceptor.class, aa);
			while(true) {
				jexoo = new Jexoo();
				XConnection xc = xa.accept("socket,host=localhost,port=8101");
				String msg = getMsg(xc);
				if(msg.equals("jexst")) {
					Jex jex = Jex.newJex("{}");
					jexoo = new Jexoo(jex);
					jexoo.setJex(jex);
					xc.write("jexcfpad".getBytes());
					xc.flush();
				}
				else jexoo.grabEq();
				xc.close();
			}
		}
		catch(Exception e){
			try{
				XComponentContext xcc = com.sun.star.comp.helper.Bootstrap.createInitialComponentContext(null);
            			XMultiComponentFactory xmsf = xcc.getServiceManager();
				Object bb = xmsf.createInstanceWithContext("com.sun.star.connection.Connector", xcc);
				XConnector xco = (XConnector) UnoRuntime.queryInterface(XConnector.class, bb);
				XConnection xc = xco.connect("socket,host=localhost,port=8101");
				xc.write("jexstpad".getBytes());
				xc.flush();
				String msg = getMsg(xc);
				if(msg.equals("jexcf")) System.exit(0);
				xc.close();
				this.destroy();
			}
			catch(Exception ee){
				System.out.println("ooListen connect exception " + ee);
			}
		}
		try{
			sleep(2000);
		}
		catch(Exception exception){
			System.err.println("ooListen exception: " + exception);
		}

		}
	}
}


